      SUBROUTINE UPINIT
      IMPLICIT NONE

#include "define.h"

      integer lunwrit,ifmt
      common /lhawrit/ lunwrit,ifmt

C...Include GR@PPA common parameter.
      INCLUDE 'grchad.inc'

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      INTEGER I,J
      CHARACTER*3 CBEAM
      CHARACTER*60 MCDBNAME
      DOUBLE PRECISION SIGMAX

C...PDF common parameter.
      CHARACTER*20      PARM(20)
      DOUBLE PRECISION  VALUE(20)

C...Initialization of GR@PPA parameters.
      CALL GRCINIT

C...Beams: 'PP' for proton-proton, and 'PAP' for proton-antiproton.
      CBEAM = 'PP'              ! LHC
C      CBEAM = 'PAP'             ! Tevatron

C...CM energy in GeV. 
      GRCECM = 14000.0D0        ! LHC
C      GRCECM =  2000.0D0        ! Tevatron

C...Kinematical cuts for "jets".
      GPTCUT   = 20.0D0         ! Pt Cut
      GETACUT  = 3.0D0          ! Eta Cut
      GRCONCUT = 0.4D0          ! RCone Cut

C   Similar cuts can be applied to each final-state particle
C   using the parameters GRCPTCUT(i), GRCETACUT(i) and GRCRCONCUT(i).
C   Furthermore, users can define their own cuts by editing the 
C   subroutine GRCUSRCUT in grcpar.F.
C
C   Users have to apply certain cuts on the separation between  
C   Z/gamma* decay products in Z/gamma* production processes.
C   For example, for the process 110, 111 and 112, activate the
C   following cuts, or define other cuts in GRCUSRCUT.
C      GRCPTCUT(1)   = 20.D0
C      GRCETACUT(1)  = 3.0D0
C      GRCRCONCUT(1) = 0.4D0
C      GRCPTCUT(2)   = 20.D0
C      GRCETACUT(2)  = 3.0D0
C      GRCRCONCUT(2) = 0.4D0

C...Set Jet flavor.
C      IGJFLV(5) = 0            ! exclude b-jets

C...Set W/Z Decay Mode. (1/0:on/off)
C      IGWMOD(1)  = 1           ! activate W -> u d
C      IGWMOD(17) = 0           ! deactivate W -> e nu
C
C      IGZMOD(1)  = 1           ! activate Z -> d dbar
C      IGZMOD(9)  = 0           ! deactivate Z -> e e

C...Set seeds for random numbers.
      IRSEED = 12345

C...Number of external processes, and process numbers. 
      NPRUP = 1
      LPRUP(1) = 101            ! W + 1 jet

C...Set PDF.
#if PDFLIB == 1
C...This flag is available only in the PYTHIA-embedding mode.

#elif PDFLIB == 2
C...Initialization of PDFLIB.
      PARM(1) = 'Init0'
      VALUE(1) = 0.0d0
      CALL PDFSET(PARM, VALUE)

C...Set PDF's of incoming beams: CTEQ 5L.
      PARM(1) = 'Nptype'
      VALUE(1) = 1
      PARM(2) = 'Ngroup'
      VALUE(2) = 4
      PARM(3) = 'Nset'
      VALUE(3) = 46
C      PARM(4) = 'LO'
C      VALUE(4) = 1
C      PARM(5) = 'NFL'
C      VALUE(5) = 5
C      PARM(6) = 'QCDL5'
C      VALUE(6) = 0.181d0
      CALL PDFSET(PARM, VALUE)

      PDFGUP(1) = VALUE(2)
      PDFSUP(1) = VALUE(3)
      PDFGUP(2) = PDFGUP(1)
      PDFSUP(2) = PDFSUP(1)

#elif PDFLIB == 3
C...Initialization of LHA PDF
      CALL InitPDFset('cteq6.LHpdf')
      CALL InitPDF(0)

      PDFGUP(1) = -1
      PDFSUP(1) = -1
      PDFGUP(2) = PDFGUP(1)
      PDFSUP(2) = PDFSUP(1)
#endif

C...Set incoming beams in the interface common.
      IF (CBEAM.EQ.'PP') THEN
         IDBMUP(1) = 2212
         IDBMUP(2) = 2212
      ELSEIF (CBEAM.EQ.'PAP') THEN
         IDBMUP(1) = 2212
         IDBMUP(2) = -2212
      ELSE
         PRINT '('' Incorrect beam definition: CBEAM = '',A4)',
     >        CBEAM
         STOP
      ENDIF
      EBMUP(1) = GRCECM/2.0D0
      EBMUP(2) = GRCECM/2.0D0

C...Decide on weighting strategy: unweighted on input.
      IDWTUP = 3

C...Check process.
      DO I = 1,NPRUP
         IF (LPRUP(I).LT.100.OR.LPRUP(I).GT.600) THEN
            WRITE(*,*) 'GRC::Error: Wrong process ID',LPRUP(I),'.'
            STOP
         ENDIF
      ENDDO

C...Only call GR@PPA.
      DO I = 1,NPRUP
         CALL GRCPYGEN(CBEAM,LPRUP(I),1,SIGMAX)
         XSECUP(i) = SIGMAX
         XMAXUP(i) = SIGMAX
      ENDDO

C  Output the header data.
      if( ifmt.eq.0 ) then
         call lhaWritHdAsc(lunwrit)
      elseif( ifmt.eq.1 ) then
         call lhaWritHdBin(lunwrit)
      endif

C...Done.
      RETURN
      END
