      program bin2asc

C  Convert the LHA External Event data written in the binary mode 
C  to the ASCII data.

C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      character*80 fileread,filewrit

      lunread= 10
      fileread= 'wj_lhaext_bin.dat'
      open(lunread,file=fileread,form='UNFORMATTED',status='OLD')

      lunwrit= 20
      filewrit= 'wj_lhaext_asc.dat'
      open(lunwrit,file=filewrit,form='FORMATTED',status='NEW')

      print *,' '
      print *,'Header info:'

C  Read the header
      call lhaReadHdBin( lunread, 0 )

C  Write the header
      call lhaWritHdAsc( lunwrit )

      print *,'-----------------------------------------------',
     >     '--------------------------------'
      print *,'IDBMUP1 IDBMUP2  EBMUP1  EBMUP2 PDFGUP1 PDFGUP2',
     >     ' PDFSUP1 PDFSUP2  IDWTUP   NPRUP'
      print '(2I8,2F8.1,4I8,2I8)',IDBMUP,EBMUP,PDFGUP,PDFSUP,
     >     IDWTUP,NPRUP
      print *,'-----------------------------------------------',
     >     '--------------------------------'
      print *,'     XSECUP      XERRUP      XMAXUP   LPRUP'
      do i=1,NPRUP
         print '(3E12.4,I8)',XSECUP(i),XERRUP(i),XMAXUP(i),LPRUP(i)
      enddo
      print *,'-----------------------------------------------',
     >     '--------------------------------'

C...Event loop.
      WRITE(*,'(/'' ########## Start the data conversion  ##########''
     >     )')

      IEV= 0
 1    continue

C  Read an event
      call lhaReadEvBin( lunread, *8 )
      IEV= IEV +1

C  Write the event
      call lhaWritEvAsc( lunwrit )

      IF (IEV.LE.5 .OR. MOD(IEV,1000).EQ.0) THEN
         WRITE(*,*) ' '
         WRITE(*,*) 'Event# ',IEV
         WRITE(*,100)
         WRITE(*,101)
         WRITE(*,102) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
         WRITE(*,100)
         WRITE(*,103)
         DO I=1,NUP
            WRITE(*,104) I,IDUP(I),ISTUP(I),(MOTHUP(J,I),J=1,2),
     >           (ICOLUP(J,I),J=1,2),(PUP(J,I),J=1,5),
     >           VTIMUP(I),SPINUP(I)  
         ENDDO
         WRITE(*,100)
      ENDIF

      goto 1

 8    continue
      WRITE(*,'(/'' ########## Conversion completed ##########''
     >     /)')
      stop

 100  FORMAT(' -----------------------------------------------------',
     >     '--------------------------------------------------------',
     >     '-----')
 101  FORMAT(5X,' NUP IDPRUP    XWGTUP    SCALUP    AQEDUP    AQCDUP')
 102  FORMAT(5X,I4,I7,4E10.3)
 103  FORMAT('     IDUP ISTUP MOTHUP1 MOTHUP2 ICOLUP1 ICOLUP2',
     >     '      PUP1      PUP2      PUP3      PUP4      PUP5',
     >     '    VTIMUP  SPINUP')
 104  FORMAT(I4,I5,I6,4I8,5F10.3,E10.3,F8.3)

      END


